

   MEMBER('embeds.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EMBEDS010.INC'),ONCE        !Local module procedure declarations
                     END


ImportTXAs PROCEDURE                                       ! Generated from procedure template - Window

txaq QUEUE(File:queue),pre()        !Inherit exact declaration of File:queue
         END
state         LONG(0)
LineNo         long

ProgressVar          LONG                                  !
Window               WINDOW('Caption'),AT(,,203,209),FONT('MS Sans Serif',8,,FONT:regular),RESIZE,GRAY,MDI,SYSTEM
                       LIST,AT(11,8,176,163),USE(?List1),VSCROLL,FORMAT('135L(2)|M~Name~10L(2)M~Date~@d1@#3#'),FROM(txaq)
                       PROGRESS,AT(11,173,176,8),USE(ProgressVar),RANGE(0,100)
                       BUTTON('&Import'),AT(44,190,45,14),USE(?import)
                       BUTTON('Close'),AT(107,190,45,14),USE(?Close)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
? DEBUGHOOK(Embed:Record)
? DEBUGHOOK(EmbedApp:Record)
? DEBUGHOOK(EmbedProc:Record)
? DEBUGHOOK(TextFile:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

CheckForMissedEmbed  routine
   if sub(txt:rec,1,8) = '[SOURCE]'
      !db.out('*** MISSED EMBED at line ' & lineno & ', state ' &  state & ' ***')
   end
!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('ImportTXAs')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Embed.Open                                        ! File Embed used by this procedure, so make sure it's RelationManager is open
  Relate:EmbedApp.Open                                     ! File EmbedApp used by this procedure, so make sure it's RelationManager is open
  Relate:EmbedProc.Open                                    ! File EmbedProc used by this procedure, so make sure it's RelationManager is open
  Relate:TextFile.Open                                     ! File TextFile used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('ImportTXAs',Window)                        ! Restore window settings from non-volatile store
  SELF.SetAlerts()
   DIRECTORY(txaq,'*.TXA',ff_:NORMAL)   !Get all files and directories
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Embed.Close
    Relate:EmbedApp.Close
    Relate:EmbedProc.Close
    Relate:TextFile.Close
  END
  IF SELF.Opened
    INIMgr.Update('ImportTXAs',Window)                     ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

x              long
vars           group,pre()
procname         string(200)
procFromABC      string(60)
procCategory     string(60)
embedname        string(60)
embedPriority    long
embedParam1      string(200)
embedParam2      string(200)
embedParam3      string(200)
whenLevel        byte
               end
dumptrace      byte(0)
LastProcName  like(procname)
lastEmbedName string(500)
currembedname string(500)
Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?import
      ThisWindow.Update
      ! Import the TXAs
      ?progressvar{prop:rangehigh} = records(txaq)
      setcursor(cursor:wait)
      Embed{prop:sql} = 'delete from Embed'
      Embed{prop:sql} = 'delete from EmbedProc'
      Embed{prop:sql} = 'delete from EmbedApp'
      loop x = 1 to records(txaq)
         get(txaq,x)
         ?progressVar{prop:progress} = x-1
         !db.out('*******************************************************************')
         !db.out('*******************************************************************')
         !db.out('*******************************************************************')
         !Db.out('TXA: ' & txaq.name)
         !db.out('*******************************************************************')
         !db.out('*******************************************************************')
         !db.out('*******************************************************************')
         clear(ema:record)
         !Access:EmbedApp.PrimeRecord()
         EMA:TXA = txaq.name
         !db.out('set ema:txa to ' & ema:txa)
         Access:EmbedApp.Insert()
         EmbedApp{prop:sql} = 'select last_insert_id()'
         next(EmbedApp)
         !db.out('EMA:EmbedAppID: ' & EMA:EmbedAppID)
 

         ! Add the queue header record
         access:TextFile.Close()
          GLO:TextFileName = txaq.name
         access:TextFile.Open()
         Access:TextFile.UseFile()
         set(TextFile)
         ProcName = ''
      
         state = 0
         lineNo = 0
         clear(procname)
         clear(lastprocname)
         clear(lastembedname)
         clear(currembedname)
         LOOP
            next(TextFile)
            if errorcode() then break.
            dumptrace = false
            lineNo += 1

   if dumptrace
            if sub(txt:rec,1,5) = '[END]'
               state = state - 1
            elsif sub(txt:rec,1,1) = '[' and sub(txt:rec,1,6) <> '[DEFIN' 
               state = state + 1
            end
            if sub(txt:rec,1,8) = '[SOURCE]'
               !db.out(all(' ',state*2) & clip(txt:rec) & ' **************************************** ')
            else
               !db.out(all(' ',state*2) & txt:rec)
            end

   else ! if not dumptrace

 
            !db.out('<-- state ' & state & ' -- ' & TXT:rec)
            CASE state
            OF 0 ! search for the start of a module or procedure, or an embed
               if sub(txt:rec,1,11) = '[PROCEDURE]'
                  ! Clear procedure/embed names
                  clear(vars)
                  state = 10
               elsif sub(txt:rec,1,8) = '[MODULE]'
                  ! New module, so clear the vars and set the proc name to [module]
                  clear(vars)
                  procName = '[MODULE]'
               elsif sub(txt:rec,1,7) = 'EMBED %'
                  embedName = sub(txt:rec,7,len(txt:rec))
                  state = 30
               elsif sub(txt:rec,1,8) = '[SOURCE]'
                  !db.out('MISSED EMBED at line ' & lineNo & ' - ' & txt:rec)
                  state = 50

               end
            OF 10 ! get procedure name details
               if sub(txt:rec,1,4) = 'NAME'
                 procName = sub(txt:rec,6,len(txt:rec))
                 !db.out('found procedure named: ' & procname)
                 state = 11
               end
               do CheckForMissedEmbed
            OF 11
               if sub(txt:rec,1,8) = 'FROM ABC'
                 procFromABC = sub(txt:rec,10,len(txt:rec))
                 !db.out('found procedure template: ' & procFromABC)
                 state = 12
               end
               do CheckForMissedEmbed
            OF 12
               if sub(txt:rec,1,8) = 'CATEGORY'
                 procCategory = sub(txt:rec,11,len(clip(txt:rec))-11)
                 !db.out('found procedure type: ' & procCategory)
               end
               ! Category is optional but if there will always follow FROM ABC
               ! - go automatically back to state 0
               state = 0
               do CheckForMissedEmbed

            of 30 ! Look for a first embed parameter 
               if sub(txt:rec,1,11) = '[INSTANCES]'
                  state = 41
               elsif sub(txt:rec,1,8) = '[SOURCE]'
                  state = 50
                  !db.out('start of embed')
               end

            of 41 ! Get first parameter
               if sub(txt:rec,1,6) = 'WHEN '''
                  embedParam1 = sub(txt:rec,7,len(clip(txt:rec))-7)
                  WhenLevel = 1
                  !db.out('whenlevel=' & whenlevel)
               end
               state = 42
               do CheckForMissedEmbed

            of 42 ! Look for a second embed parameter
               if sub(txt:rec,1,11) = '[INSTANCES]'
                  state = 43
               elsif sub(txt:rec,1,8) = '[SOURCE]'
                  state = 50
                  !db.out('found PRIORITY')
               end

            of 43 ! Get second parameter
               if sub(txt:rec,1,6) = 'WHEN '''
                  embedParam2 = sub(txt:rec,7,len(clip(txt:rec))-7)
                  WhenLevel = 2
                  !db.out('whenlevel=' & whenlevel)
               end
               state = 44
               do CheckForMissedEmbed

            of 44 ! Look for a third embed parameter
               if sub(txt:rec,1,11) = '[INSTANCES]'
                  state = 45
               elsif sub(txt:rec,1,8) = '[SOURCE]'
                  state = 50
                  !db.out('found PRIORITY')
               end

            of 45 ! Get third parameter
               if sub(txt:rec,1,6) = 'WHEN '''
                  embedParam3 = sub(txt:rec,7,len(clip(txt:rec))-7)
                  WhenLevel = 3
                  !db.out('whenlevel=' & whenlevel)
               end
               state = 50
               do CheckForMissedEmbed


            of 50  ! look for the priority
               if sub(txt:rec,1,8) = 'PRIORITY'
                  embedPriority = sub(txt:rec,10,len(txt:rec))
!                  db.out(' ')
!                  db.out('*************************************************************************************************')
!                  db.out('** procName     : ' & procName)
!                  db.out('** procFromABC  : ' & procFromABC)
!                  db.out('** procCategory : ' & procCategory)
!                  db.out('** embedName    : ' & embedName)
!                  db.out('** embedParam1  : ' & embedParam1)
!                  db.out('** embedParam2  : ' & embedParam2)
!                  db.out('** embedParam3  : ' & embedParam3)
!                  db.out('** embedPriority: ' & embedPriority)
!                  db.out('*************************************************************************************************')
         !dgh
                  if lastprocname <> procname
                     ! insert new EmbedProc record
                     clear(EMP:record)
                     EMP:Proc = procname
                     EMP:ProcFromABC = ProcFromABC
                     EMP:ProcCategory = ProcCategory
                     EMP:EmbedAppID = EMA:EmbedAppID
                     Access:EmbedProc.Insert()
                     EmbedProc{prop:sql} = 'select last_insert_id()'
                     next(EmbedProc)

                     lastprocname = procname
                  end
                  ! Add the embed record
                  currEmbedName = clip(embedName) & clip(embedparam1) & clip(embedparam2) & clip(embedparam3) & embedpriority
                  if currEmbedName <> lastEmbedName
                     lastEmbedName = currEmbedName
                     EMB:EmbedProcID = EMP:EmbedProcID
                     EMB:Embed = EmbedName
                     EMB:Param1 = EmbedParam1
                     EMB:Param2 = EmbedParam2
                     EMB:Param3 = EmbedParam3
                     EMB:Priority = embedpriority
                     access:Embed.Insert()
                   !db.out('proc: ' & clip(procname) & ', fromABC: ' & clip(procFromABC) & ', Category: ' |
                   !  & clip(procCategory) & ', embed: ' & clip(embedname) & |
                   !  choose(embedParam1 <> '',clip(embedParam1) & ',','') & |
                   !  choose(embedParam2 <> '',clip(embedParam2) & ',','') & |
                   !  choose(embedParam3 <> '',clip(embedParam3) & ',','') & |
                   !  ', priority: ' & embedPriority)
                  end

                  state = 51

                end

            of 51
               state = 60
               do CheckForMissedEmbed

            OF 60  ! capturing embed
               ! Quit when [END] encountered
               if sub(txt:rec,1,1) = '['
                  if sub(txt:rec,1,5) = '[END]'
                     case WhenLevel
                     of 3
                        WhenLevel = 2
                        embedParam3 = ''
                     of 2
                        WhenLevel = 1
                        embedParam2 = ''
                     of 1
                        WhenLevel = 0
                        embedParam1 = ''
                     end
                     state = 0

                  elsif sub(txt:rec,1,8) = '[SOURCE]'
                     ! look for another embed under this [EMBED] point
                    state = 50
                  else
                     ! could be we're done
                     state = 0
                  end
!                  db.out('*************************************************************************************************')
              elsif sub(txt:rec,1,6) = 'WHEN '''
                  case WhenLevel
                  of 0
                     ! get the first param
                     embedParam1 = sub(txt:rec,7,len(clip(txt:rec))-7)
                     WhenLevel = 1
                     state = 42
                  of 1
                     ! get the second param
                     embedParam2 = sub(txt:rec,7,len(clip(txt:rec))-7)
                     WhenLevel = 2
                     state = 50
                  of 2
                     state = 50
                  end
!                  db.out('*************************************************************************************************')

               else
                  ! write embed buffer to file
!                  db.out('** text        : ' & txt:rec)
               end
            else
               !db.out('*** no code for state ' & state & ' ***')
               do CheckForMissedEmbed


            END
   end ! if dumptrace
      
         END
         Access:TextFile.Close()
      
         ! loop through all the procedures
         ! for each procedure, get all the embeds
      end
         ?progressVar{prop:progress} = records(txaq)
      setcursor()
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

