

   MEMBER('embeds.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EMBEDS002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EMBEDS005.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('EMBEDS006.INC'),ONCE        !Req'd for module callout resolution
                     END


BrowseEmbed PROCEDURE                                      ! Generated from procedure template - Window

!embed
CurrentTab           STRING(80)                            !
!embed
BRW1::View:Browse    VIEW(Embed)
                       PROJECT(EMB:EmbedID)
                       PROJECT(EMB:EmbedProcID)
                       PROJECT(EMB:LinesOfCode)
                       PROJECT(EMB:Embed)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
EMB:EmbedID            LIKE(EMB:EmbedID)              !List box control field - type derived from field
EMB:EmbedProcID        LIKE(EMB:EmbedProcID)          !List box control field - type derived from field
EMB:LinesOfCode        LIKE(EMB:LinesOfCode)          !List box control field - type derived from field
EMB:Embed              LIKE(EMB:Embed)                !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
!embed
QuickWindow          WINDOW('Browse the Embed file'),AT(,,280,198),FONT('MS Sans Serif',8,,FONT:regular),RESIZE, |
  CENTER,GRAY,IMM,MDI,HLP('BrowseEmbed'),SYSTEM
                       LIST,AT(8,30,264,124),USE(?Browse:1),HVSCROLL,FORMAT('64R(2)|M~Embed ID~C(0)@n-14@64R(2' & |
  ')|M~Embed Proc ID~C(0)@n-14@64R(2)|M~Lines Of Code~C(0)@n-14@80L(2)|M~Embed~L(2)@s255@'), |
  FROM(Queue:Browse:1),IMM,MSG('Browsing the Embed file')
                       BUTTON('&View'),AT(64,158,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Insert'),AT(117,158,49,14),USE(?Insert:3),LEFT,ICON('WAINSERT.ICO'),FLAT,MSG('Insert a Record'), |
  TIP('Insert a Record')
                       BUTTON('&Change'),AT(170,158,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Delete'),AT(223,158,49,14),USE(?Delete:3),LEFT,ICON('WADELETE.ICO'),FLAT,MSG('Delete the Record'), |
  TIP('Delete the Record')
                       SHEET,AT(4,4,272,172),USE(?CurrentTab)
                         TAB('&1) PRIMARY'),USE(?Tab:2)
                         END
                         TAB('&2) EmbedProcIDIndex'),USE(?Tab:3)
                           BUTTON('Select EmbedProc'),AT(8,158,118,14),USE(?SelectEmbedProc),LEFT,ICON('WAPARENT.ICO'), |
  FLAT,MSG('Select Parent Field'),TIP('Select Parent Field')
                         END
                       END
                       BUTTON('&Close'),AT(174,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(227,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

!embed
ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
ChangeAction           PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
DeleteAction           PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
InsertAction           PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Open                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Open                   PROCEDURE(*Window pWindow,<*Window pOwner>),DERIVED ! Method added to host embed code
PrimeFields            PROCEDURE(),PROC,DERIVED            ! Method added to host embed code
PrimeUpdate            PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Reset                  PROCEDURE(BYTE Force=0),DERIVED     ! Method added to host embed code
RestoreField           PROCEDURE(SIGNED Control),DERIVED   ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
SaveOnChangeAction     PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
SaveOnInsertAction     PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
SetAlerts              PROCEDURE(),DERIVED                 ! Method added to host embed code
SetResponse            PROCEDURE(BYTE Response),DERIVED    ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeNewSelection       PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeNotify             PROCEDURE(UNSIGNED NotifyCode,SIGNED Thread,LONG Parameter),BYTE,PROC,DERIVED ! Method added to host embed code
TakeRejected           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Update                 PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Toolbar              CLASS(ToolbarClass)
DisplayButtons         PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE()                         ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
TakeEvent              PROCEDURE(<*LONG VCR>,WindowManager WM),DERIVED ! Method added to host embed code
                     END

BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
AppendOrder            PROCEDURE(STRING Order),DERIVED     ! Method added to host embed code
ApplyFilter            PROCEDURE(),DERIVED                 ! Method added to host embed code
ApplyOrder             PROCEDURE(),DERIVED                 ! Method added to host embed code
ApplyRange             PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Ask                    PROCEDURE(BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
AskRecord              PROCEDURE(BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
ClearFilesRecord       PROCEDURE(),DERIVED                 ! Method added to host embed code
Close                  PROCEDURE(),DERIVED                 ! Method added to host embed code
Close                  PROCEDURE(BYTE Force),DERIVED       ! Method added to host embed code
Destruct               PROCEDURE(),DERIVED                 ! Method added to host embed code
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
GetFreeElementAscending PROCEDURE(),STRING,DERIVED         ! Method added to host embed code
GetFreeElementName     PROCEDURE(),STRING,DERIVED          ! Method added to host embed code
GetFreeElementPosition PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
GetUseMRP              PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
Init                   PROCEDURE(IListControl IC,VIEW V,BrowseQueue LQ,RelationManager RM,WindowManager WM) ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
Init                   PROCEDURE(VIEW V,RelationManager RM,<SortOrder SO>) ! Method added to host embed code
InitSort               PROCEDURE(BYTE NewOrder),BYTE,DERIVED ! Method added to host embed code
Kill                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Next                   PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
NotifyUpdateError      PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
Open                   PROCEDURE(),DERIVED                 ! Method added to host embed code
Previous               PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
PrimeRecord            PROCEDURE(BYTE SuppressClear = 0),BYTE,PROC,DERIVED ! Method added to host embed code
Reset                  PROCEDURE(),DERIVED                 ! Method added to host embed code
Reset                  PROCEDURE(BYTE Locate),DERIVED      ! Method added to host embed code
ResetFromAsk           PROCEDURE(*BYTE Request,*BYTE Response),DERIVED ! Method added to host embed code
ResetFromBuffer        PROCEDURE(),DERIVED                 ! Method added to host embed code
ResetFromFile          PROCEDURE(),DERIVED                 ! Method added to host embed code
ResetFromView          PROCEDURE(),DERIVED                 ! Method added to host embed code
ResetQueue             PROCEDURE(BYTE ResetMode),DERIVED   ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
RestoreBuffers         PROCEDURE(),DERIVED                 ! Method added to host embed code
SaveBuffers            PROCEDURE(),DERIVED                 ! Method added to host embed code
ScrollEnd              PROCEDURE(SIGNED Event),DERIVED     ! Method added to host embed code
ScrollOne              PROCEDURE(SIGNED Event),DERIVED     ! Method added to host embed code
ScrollPage             PROCEDURE(SIGNED Event),DERIVED     ! Method added to host embed code
SetAlerts              PROCEDURE(),DERIVED                 ! Method added to host embed code
SetFilter              PROCEDURE(STRING Filter),DERIVED    ! Method added to host embed code
SetFilter              PROCEDURE(STRING Filter,STRING Id),DERIVED ! Method added to host embed code
SetOrder               PROCEDURE(STRING Order),DERIVED     ! Method added to host embed code
SetQueueRecord         PROCEDURE(),DERIVED                 ! Method added to host embed code
SetSort                PROCEDURE(BYTE NewOrder,BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
SetSort                PROCEDURE(BYTE OrderNumber),BYTE,PROC,DERIVED ! Method added to host embed code
SetUseMRP              PROCEDURE(BYTE UseMRP=True),DERIVED ! Method added to host embed code
SetUsePopup            PROCEDURE(BYTE UsePopUp=True),DERIVED ! Method added to host embed code
TakeAcceptedLocator    PROCEDURE(),DERIVED                 ! Method added to host embed code
TakeEvent              PROCEDURE(),DERIVED                 ! Method added to host embed code
TakeKey                PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeLocate             PROCEDURE(),DERIVED                 ! Method added to host embed code
TakeNewSelection       PROCEDURE(),DERIVED                 ! Method added to host embed code
TakeScroll             PROCEDURE(SIGNED Event = 0),DERIVED ! Method added to host embed code
TakeVCRScroll          PROCEDURE(SIGNED Vcr = 0),DERIVED   ! Method added to host embed code
UpdateBuffer           PROCEDURE(),DERIVED                 ! Method added to host embed code
UpdateResets           PROCEDURE(),DERIVED                 ! Method added to host embed code
UpdateThumb            PROCEDURE(),DERIVED                 ! Method added to host embed code
UpdateThumbFixed       PROCEDURE(),DERIVED                 ! Method added to host embed code
UpdateViewRecord       PROCEDURE(),DERIVED                 ! Method added to host embed code
UpdateWindow           PROCEDURE(),DERIVED                 ! Method added to host embed code
ValidateRecord         PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
                     END

BRW1::Sort0:Locator  CLASS(StepLocatorClass)               ! Default Locator
Destruct               PROCEDURE(),DERIVED                 ! Method added to host embed code
GetShadow              PROCEDURE(),STRING,DERIVED          ! Method added to host embed code
Init                   PROCEDURE(SIGNED Control = 0,*? Free,BYTE NoCase = 0),DERIVED ! Method added to host embed code
Init                   PROCEDURE(SIGNED Control = 0,*? Free,BYTE NoCase = 0,BrowseClass BC) ! Method added to host embed code
Init                   PROCEDURE(SIGNED Control = 0,*? Free,BYTE NoCase = 0,ViewManager VM) ! Method added to host embed code
Reset                  PROCEDURE(),DERIVED                 ! Method added to host embed code
Set                    PROCEDURE(),DERIVED                 ! Method added to host embed code
SetAlerts              PROCEDURE(SIGNED FieldEquate),DERIVED ! Method added to host embed code
SetEnabled             PROCEDURE(BYTE B),DERIVED           ! Method added to host embed code
SetLocatorField        PROCEDURE(*? Free),DERIVED          ! Method added to host embed code
SetShadow              PROCEDURE(STRING S),DERIVED         ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
TakeKey                PROCEDURE(),BYTE,DERIVED            ! Method added to host embed code
UpdateWindow           PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

Resizer              CLASS(WindowResizeClass)
GetParentControl       PROCEDURE(SIGNED Control),SIGNED,DERIVED ! Method added to host embed code
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
Reset                  PROCEDURE(),DERIVED                 ! Method added to host embed code
Resize                 PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Resize                 PROCEDURE(SIGNED Control),BYTE,PROC,DERIVED ! Method added to host embed code
RestoreWindow          PROCEDURE(),DERIVED                 ! Method added to host embed code
SetParentDefault       PROCEDURE(),DERIVED                 ! Method added to host embed code
SetParentDefaults      PROCEDURE(),DERIVED                 ! Method added to host embed code
SetPosition            PROCEDURE(SIGNED Control,*PositionGroup ParentOrigPos,*PositionGroup ParentNewPos,*PositionGroup OrigPos,*PositionGroup NewPos),DERIVED ! Method added to host embed code
                     END

!embed

  CODE
? DEBUGHOOK(Embed:Record)
? DEBUGHOOK(EmbedProc:Record)
!embed
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!embed
!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!embed
!embed
!---------------------------------------------------------------------------
!embed

ThisWindow.Ask PROCEDURE

!embed
  CODE
!embed
  PARENT.Ask
!embed


ThisWindow.ChangeAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.ChangeAction()
!embed
  RETURN ReturnValue


ThisWindow.DeleteAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.DeleteAction()
!embed
  RETURN ReturnValue


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  GlobalErrors.SetProcedureName('BrowseEmbed')
!embed
  SELF.Request = GlobalRequest                             ! Store the incoming request
!embed
  ReturnValue = PARENT.Init()
!embed
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
!embed
!embed
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
!embed
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
!embed
  Relate:Embed.Open                                        ! File Embed used by this procedure, so make sure it's RelationManager is open
  Relate:EmbedProc.Open                                    ! File EmbedProc used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
!embed
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Embed,SELF) ! Initialize the browse manager
!embed
  SELF.Open(QuickWindow)                                   ! Open window
!embed
  Do DefineListboxStyle
!embed
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,EMB:EmbedProcIDIndex)                 ! Add the sort order for EMB:EmbedProcIDIndex for sort order 1
  BRW1.AddRange(EMB:EmbedProcID,Relate:Embed,Relate:EmbedProc) ! Add file relationship range limit for sort order 1
  BRW1.AddSortOrder(,EMB:PRIMARY)                          ! Add the sort order for EMB:PRIMARY for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(,EMB:EmbedID,,BRW1)             ! Initialize the browse locator using  using key: EMB:PRIMARY , EMB:EmbedID
  BRW1.AddField(EMB:EmbedID,BRW1.Q.EMB:EmbedID)            ! Field EMB:EmbedID is a hot field or requires assignment from browse
  BRW1.AddField(EMB:EmbedProcID,BRW1.Q.EMB:EmbedProcID)    ! Field EMB:EmbedProcID is a hot field or requires assignment from browse
  BRW1.AddField(EMB:LinesOfCode,BRW1.Q.EMB:LinesOfCode)    ! Field EMB:LinesOfCode is a hot field or requires assignment from browse
  BRW1.AddField(EMB:Embed,BRW1.Q.EMB:Embed)                ! Field EMB:Embed is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
!embed
  INIMgr.Fetch('BrowseEmbed',QuickWindow)                  ! Restore window settings from non-volatile store
!embed
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
!embed
  BRW1.AskProcedure = 1
!embed
!embed
  SELF.SetAlerts()
!embed
  RETURN ReturnValue


ThisWindow.InsertAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.InsertAction()
!embed
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
!embed
  ReturnValue = PARENT.Kill()
!embed
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
!embed
    Relate:Embed.Close
    Relate:EmbedProc.Close
!embed
  END
!embed
  IF SELF.Opened
    INIMgr.Update('BrowseEmbed',QuickWindow)               ! Save window data to non-volatile store
  END
!embed
  GlobalErrors.SetProcedureName
!embed
  RETURN ReturnValue


ThisWindow.Open PROCEDURE

!embed
  CODE
!embed
  PARENT.Open
!embed


ThisWindow.Open PROCEDURE(*Window pWindow,<*Window pOwner>)

!embed
  CODE
!embed
  PARENT.Open(pWindow,pOwner)
!embed


ThisWindow.PrimeFields PROCEDURE

!embed
  CODE
!embed
  PARENT.PrimeFields
!embed


ThisWindow.PrimeUpdate PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.PrimeUpdate()
!embed
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

!embed
  CODE
!embed
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
!embed
!embed
!embed
  PARENT.Reset(Force)
!embed


ThisWindow.RestoreField PROCEDURE(SIGNED Control)

!embed
  CODE
!embed
  PARENT.RestoreField(Control)
!embed


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Run()
!embed
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Run(Number,Request)
!embed
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateEmbed
    ReturnValue = GlobalResponse
  END
!embed
  RETURN ReturnValue


ThisWindow.SaveOnChangeAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.SaveOnChangeAction()
!embed
  RETURN ReturnValue


ThisWindow.SaveOnInsertAction PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.SaveOnInsertAction()
!embed
  RETURN ReturnValue


ThisWindow.SetAlerts PROCEDURE

!embed
  CODE
!embed
  PARENT.SetAlerts
!embed


ThisWindow.SetResponse PROCEDURE(BYTE Response)

!embed
  CODE
!embed
  PARENT.SetResponse(Response)
!embed


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
    CASE ACCEPTED()
    OF ?Browse:1
!embed
    OF ?View:2
!embed
    OF ?Insert:3
!embed
    OF ?Change:3
!embed
    OF ?Delete:3
!embed
    OF ?CurrentTab
!embed
    OF ?SelectEmbedProc
!embed
    OF ?Close
!embed
    OF ?Help
!embed
!embed
    ELSE
!embed
    END
!embed
  ReturnValue = PARENT.TakeAccepted()
!embed
    CASE ACCEPTED()
    OF ?Browse:1
!embed
    OF ?View:2
      ThisWindow.Update
!embed
    OF ?Insert:3
      ThisWindow.Update
!embed
    OF ?Change:3
      ThisWindow.Update
!embed
    OF ?Delete:3
      ThisWindow.Update
!embed
    OF ?CurrentTab
!embed
    OF ?SelectEmbedProc
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectEmbedProc()
      ThisWindow.Reset
!embed
    OF ?Close
      ThisWindow.Update
!embed
    OF ?Help
      ThisWindow.Update
!embed
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeFieldEvent()
  CASE FIELD()
  OF ?Browse:1
    CASE EVENT()
    OF EVENT:PageUp
!embed
    OF EVENT:PageDown
!embed
    OF EVENT:ScrollTop
!embed
    OF EVENT:ScrollBottom
!embed
    OF EVENT:ScrollTrack
!embed
    OF EVENT:ScrollDrag
!embed
    OF EVENT:AlertKey
!embed
    OF EVENT:PreAlertKey
!embed
    OF EVENT:ColumnResize
!embed
    ELSE
!embed
    END
!embed
  OF ?View:2
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Insert:3
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Change:3
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Delete:3
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?CurrentTab
!embed
    CASE EVENT()
!embed
    OF EVENT:TabChanging
!embed
    ELSE
!embed
    END
!embed
  OF ?Tab:2
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Tab:3
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?SelectEmbedProc
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Close
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
  OF ?Help
!embed
    CASE EVENT()
!embed
    ELSE
!embed
    END
!embed
!embed
  END
!embed
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeNewSelection PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receives all NewSelection events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
    CASE FIELD()
    OF ?Browse:1
!embed
    OF ?CurrentTab
!embed
    END
!embed
  ReturnValue = PARENT.TakeNewSelection()
!embed
    CASE FIELD()
    OF ?Browse:1
!embed
    OF ?CurrentTab
!embed
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeNotify PROCEDURE(UNSIGNED NotifyCode,SIGNED Thread,LONG Parameter)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.TakeNotify(NotifyCode,Thread,Parameter)
!embed
  RETURN ReturnValue


ThisWindow.TakeRejected PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receives all Rejected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
  ReturnValue = PARENT.TakeRejected()
!embed
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
!embed
    CASE FIELD()
    OF ?Browse:1
!embed
    OF ?View:2
!embed
    OF ?Insert:3
!embed
    OF ?Change:3
!embed
    OF ?Delete:3
!embed
    OF ?CurrentTab
!embed
    OF ?SelectEmbedProc
!embed
    OF ?Close
!embed
    OF ?Help
!embed
    END
!embed
  ReturnValue = PARENT.TakeSelected()
!embed
    CASE FIELD()
    OF ?Browse:1
!embed
    OF ?View:2
!embed
    OF ?Insert:3
!embed
    OF ?Change:3
!embed
    OF ?Delete:3
!embed
    OF ?CurrentTab
!embed
    OF ?SelectEmbedProc
!embed
    OF ?Close
!embed
    OF ?Help
!embed
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

!embed
Looped BYTE
!embed
  CODE
!embed
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
!embed
    OF EVENT:AlertKey
!embed
    OF EVENT:CloseDown
!embed
    OF EVENT:CloseWindow
!embed
    OF EVENT:DoResize
!embed
    OF EVENT:GainFocus
!embed
    OF EVENT:Iconize
!embed
    OF EVENT:Iconized
!embed
    OF EVENT:LoseFocus
!embed
    OF EVENT:Maximize
!embed
    OF EVENT:Maximized
!embed
    OF EVENT:Move
!embed
    OF EVENT:Moved
!embed
    OF EVENT:Notify
!embed
    OF EVENT:OpenWindow
!embed
    OF EVENT:PreAlertKey
!embed
    OF EVENT:Restore
!embed
    OF EVENT:Restored
!embed
    OF EVENT:Size
!embed
    OF EVENT:Sized
!embed
    END
!embed
  ReturnValue = PARENT.TakeWindowEvent()
!embed
    CASE EVENT()
    OF EVENT:AlertKey
!embed
    OF EVENT:CloseDown
!embed
    OF EVENT:CloseWindow
!embed
    OF EVENT:DoResize
!embed
    OF EVENT:GainFocus
!embed
    OF EVENT:Iconize
!embed
    OF EVENT:Iconized
!embed
    OF EVENT:LoseFocus
!embed
    OF EVENT:Maximize
!embed
    OF EVENT:Maximized
!embed
    OF EVENT:Move
!embed
    OF EVENT:Moved
!embed
    OF EVENT:Notify
!embed
    OF EVENT:OpenWindow
!embed
    OF EVENT:PreAlertKey
!embed
    OF EVENT:Restore
!embed
    OF EVENT:Restored
!embed
    OF EVENT:Size
!embed
    OF EVENT:Sized
!embed
!embed
    ELSE
!embed
    END
!embed
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
!embed
  RETURN ReturnValue


ThisWindow.Update PROCEDURE

!embed
  CODE
!embed
  PARENT.Update
!embed
!embed


Toolbar.DisplayButtons PROCEDURE

!embed
  CODE
!embed
  PARENT.DisplayButtons
!embed


Toolbar.Init PROCEDURE

!embed
  CODE
!embed
  PARENT.Init
!embed


Toolbar.Kill PROCEDURE

!embed
  CODE
!embed
  PARENT.Kill
!embed


Toolbar.TakeEvent PROCEDURE(<*LONG VCR>,WindowManager WM)

!embed
  CODE
!embed
  PARENT.TakeEvent(VCR,WM)
!embed

!embed

BRW1.AppendOrder PROCEDURE(STRING Order)

!embed
  CODE
!embed
  PARENT.AppendOrder(Order)
!embed


BRW1.ApplyFilter PROCEDURE

!embed
  CODE
!embed
  PARENT.ApplyFilter
!embed


BRW1.ApplyOrder PROCEDURE

!embed
  CODE
!embed
  PARENT.ApplyOrder
!embed


BRW1.ApplyRange PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
!embed
  ReturnValue = PARENT.ApplyRange()
!embed
  RETURN ReturnValue


BRW1.Ask PROCEDURE(BYTE Request)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Ask(Request)
!embed
  RETURN ReturnValue


BRW1.AskRecord PROCEDURE(BYTE Request)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.AskRecord(Request)
!embed
  RETURN ReturnValue


BRW1.ClearFilesRecord PROCEDURE

!embed
  CODE
!embed
  PARENT.ClearFilesRecord
!embed


BRW1.Close PROCEDURE

!embed
  CODE
!embed
  PARENT.Close
!embed


BRW1.Close PROCEDURE(BYTE Force)

!embed
  CODE
!embed
  PARENT.Close(Force)
!embed


BRW1.Destruct PROCEDURE

!embed
  CODE
!embed


BRW1.Fetch PROCEDURE(BYTE Direction)

!embed
GreenBarIndex   LONG
!embed
  CODE
!embed
  PARENT.Fetch(Direction)
!embed


BRW1.GetFreeElementAscending PROCEDURE

ReturnValue          ANY

!embed
  CODE
!embed
  ReturnValue = PARENT.GetFreeElementAscending()
!embed
  RETURN ReturnValue


BRW1.GetFreeElementName PROCEDURE

ReturnValue          ANY

!embed
  CODE
!embed
  ReturnValue = PARENT.GetFreeElementName()
!embed
  RETURN ReturnValue


BRW1.GetFreeElementPosition PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.GetFreeElementPosition()
!embed
  RETURN ReturnValue


BRW1.GetUseMRP PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.GetUseMRP()
!embed
  RETURN ReturnValue


BRW1.Init PROCEDURE(IListControl IC,VIEW V,BrowseQueue LQ,RelationManager RM,WindowManager WM)

!embed
  CODE
!embed
  PARENT.Init(IC,V,LQ,RM,WM)
!embed


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

!embed
  CODE
!embed
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
!embed
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
!embed
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode
!embed


BRW1.Init PROCEDURE(VIEW V,RelationManager RM,<SortOrder SO>)

!embed
  CODE
!embed
  PARENT.Init(V,RM,SO)
!embed


BRW1.InitSort PROCEDURE(BYTE NewOrder)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.InitSort(NewOrder)
!embed
  RETURN ReturnValue


BRW1.Kill PROCEDURE

!embed
  CODE
!embed
  PARENT.Kill
!embed


BRW1.Next PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Next()
!embed
  RETURN ReturnValue


BRW1.NotifyUpdateError PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.NotifyUpdateError()
!embed
  RETURN ReturnValue


BRW1.Open PROCEDURE

!embed
  CODE
!embed
  PARENT.Open
!embed


BRW1.Previous PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.Previous()
!embed
  RETURN ReturnValue


BRW1.PrimeRecord PROCEDURE(BYTE SuppressClear = 0)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.PrimeRecord(SuppressClear)
!embed
  RETURN ReturnValue


BRW1.Reset PROCEDURE

!embed
  CODE
!embed
  PARENT.Reset
!embed


BRW1.Reset PROCEDURE(BYTE Locate)

!embed
  CODE
!embed
  PARENT.Reset(Locate)
!embed


BRW1.ResetFromAsk PROCEDURE(*BYTE Request,*BYTE Response)

!embed
  CODE
!embed
  PARENT.ResetFromAsk(Request,Response)
!embed


BRW1.ResetFromBuffer PROCEDURE

!embed
  CODE
!embed
  PARENT.ResetFromBuffer
!embed


BRW1.ResetFromFile PROCEDURE

!embed
  CODE
!embed
  PARENT.ResetFromFile
!embed


BRW1.ResetFromView PROCEDURE

!embed
  CODE
!embed
  SETCURSOR(Cursor:Wait)
  Relate:Embed.SetQuickScan(1)
  SELF.Reset
!embed
  IF SELF.UseMRP
     IF SELF.View{PROP:IPRequestCount} = 0
          SELF.View{PROP:IPRequestCount} = 60
     END
  END
  LOOP
    IF SELF.UseMRP
       IF SELF.View{PROP:IPRequestCount} = 0
            SELF.View{PROP:IPRequestCount} = 60
       END
    END
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      SETCURSOR()
      RETURN
    END
!embed
    SELF.SetQueueRecord
!embed
  END
  SELF.View{PROP:IPRequestCount} = 0
!embed
  PARENT.ResetFromView
!embed
  Relate:Embed.SetQuickScan(0)
  SETCURSOR()
!embed


BRW1.ResetQueue PROCEDURE(BYTE ResetMode)

!embed
  CODE
!embed
  PARENT.ResetQueue(ResetMode)
!embed


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
!embed
  ReturnValue = PARENT.ResetSort(Force)
!embed
  RETURN ReturnValue


BRW1.RestoreBuffers PROCEDURE

!embed
  CODE
!embed
  PARENT.RestoreBuffers
!embed


BRW1.SaveBuffers PROCEDURE

!embed
  CODE
!embed
  PARENT.SaveBuffers
!embed


BRW1.ScrollEnd PROCEDURE(SIGNED Event)

!embed
  CODE
!embed
  PARENT.ScrollEnd(Event)
!embed


BRW1.ScrollOne PROCEDURE(SIGNED Event)

!embed
  CODE
!embed
  PARENT.ScrollOne(Event)
!embed


BRW1.ScrollPage PROCEDURE(SIGNED Event)

!embed
  CODE
!embed
  PARENT.ScrollPage(Event)
!embed


BRW1.SetAlerts PROCEDURE

!embed
  CODE
!embed
  PARENT.SetAlerts
!embed


BRW1.SetFilter PROCEDURE(STRING Filter)

!embed
  CODE
!embed
  PARENT.SetFilter(Filter)
!embed


BRW1.SetFilter PROCEDURE(STRING Filter,STRING Id)

!embed
  CODE
!embed
  PARENT.SetFilter(Filter,Id)
!embed


BRW1.SetOrder PROCEDURE(STRING Order)

!embed
  CODE
!embed
  PARENT.SetOrder(Order)
!embed


BRW1.SetQueueRecord PROCEDURE

!embed
  CODE
!embed
  PARENT.SetQueueRecord
!embed
  
!embed


BRW1.SetSort PROCEDURE(BYTE NewOrder,BYTE Force)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.SetSort(NewOrder,Force)
!embed
  RETURN ReturnValue


BRW1.SetSort PROCEDURE(BYTE OrderNumber)

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.SetSort(OrderNumber)
!embed
  RETURN ReturnValue


BRW1.SetUseMRP PROCEDURE(BYTE UseMRP=True)

!embed
  CODE
!embed
  PARENT.SetUseMRP(UseMRP)
!embed


BRW1.SetUsePopup PROCEDURE(BYTE UsePopUp=True)

!embed
  CODE
!embed
  PARENT.SetUsePopup(UsePopUp)
!embed


BRW1.TakeAcceptedLocator PROCEDURE

!embed
  CODE
!embed
  PARENT.TakeAcceptedLocator
!embed


BRW1.TakeEvent PROCEDURE

!embed
  CODE
!embed
  PARENT.TakeEvent
!embed


BRW1.TakeKey PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.TakeKey()
!embed
  RETURN ReturnValue


BRW1.TakeLocate PROCEDURE

!embed
  CODE
!embed
  PARENT.TakeLocate
!embed


BRW1.TakeNewSelection PROCEDURE

!embed
  CODE
!embed
  PARENT.TakeNewSelection
!embed


BRW1.TakeScroll PROCEDURE(SIGNED Event = 0)

!embed
  CODE
!embed
  PARENT.TakeScroll(Event)
!embed


BRW1.TakeVCRScroll PROCEDURE(SIGNED Vcr = 0)

!embed
  CODE
!embed
  PARENT.TakeVCRScroll(Vcr)
!embed


BRW1.UpdateBuffer PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateBuffer
!embed


BRW1.UpdateResets PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateResets
!embed


BRW1.UpdateThumb PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateThumb
!embed


BRW1.UpdateThumbFixed PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateThumbFixed
!embed


BRW1.UpdateViewRecord PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateViewRecord
!embed


BRW1.UpdateWindow PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateWindow
!embed


BRW1.ValidateRecord PROCEDURE

ReturnValue          BYTE,AUTO

!embed
BRW1::RecordStatus   BYTE,AUTO
!embed
  CODE
!embed
  ReturnValue = PARENT.ValidateRecord()
!embed
  BRW1::RecordStatus=ReturnValue
  IF BRW1::RecordStatus NOT=Record:OK THEN RETURN BRW1::RecordStatus.
!embed
  ReturnValue=BRW1::RecordStatus
!embed
  RETURN ReturnValue


BRW1::Sort0:Locator.Destruct PROCEDURE

!embed
  CODE
!embed


BRW1::Sort0:Locator.GetShadow PROCEDURE

ReturnValue          ANY

!embed
  CODE
!embed
  ReturnValue = PARENT.GetShadow()
!embed
  RETURN ReturnValue


BRW1::Sort0:Locator.Init PROCEDURE(SIGNED Control = 0,*? Free,BYTE NoCase = 0)

!embed
  CODE
!embed
  PARENT.Init(Control,Free,NoCase)
!embed


BRW1::Sort0:Locator.Init PROCEDURE(SIGNED Control = 0,*? Free,BYTE NoCase = 0,BrowseClass BC)

!embed
  CODE
!embed
  PARENT.Init(Control,Free,NoCase,BC)
!embed


BRW1::Sort0:Locator.Init PROCEDURE(SIGNED Control = 0,*? Free,BYTE NoCase = 0,ViewManager VM)

!embed
  CODE
!embed
  PARENT.Init(Control,Free,NoCase,VM)
!embed


BRW1::Sort0:Locator.Reset PROCEDURE

!embed
  CODE
!embed
  PARENT.Reset
!embed


BRW1::Sort0:Locator.Set PROCEDURE

!embed
  CODE
!embed
  PARENT.Set
!embed


BRW1::Sort0:Locator.SetAlerts PROCEDURE(SIGNED FieldEquate)

!embed
  CODE
!embed
  PARENT.SetAlerts(FieldEquate)
!embed


BRW1::Sort0:Locator.SetEnabled PROCEDURE(BYTE B)

!embed
  CODE
!embed
  PARENT.SetEnabled(B)
!embed


BRW1::Sort0:Locator.SetLocatorField PROCEDURE(*? Free)

!embed
  CODE
!embed
  PARENT.SetLocatorField(Free)
!embed


BRW1::Sort0:Locator.SetShadow PROCEDURE(STRING S)

!embed
  CODE
!embed
  PARENT.SetShadow(S)
!embed


BRW1::Sort0:Locator.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.TakeAccepted()
!embed
  RETURN ReturnValue


BRW1::Sort0:Locator.TakeKey PROCEDURE

ReturnValue          BYTE,AUTO

!embed
  CODE
!embed
  ReturnValue = PARENT.TakeKey()
!embed
  RETURN ReturnValue


BRW1::Sort0:Locator.UpdateWindow PROCEDURE

!embed
  CODE
!embed
  PARENT.UpdateWindow
!embed


Resizer.GetParentControl PROCEDURE(SIGNED Control)

ReturnValue          SIGNED,AUTO

!embed

  CODE
!embed
  ReturnValue = PARENT.GetParentControl(Control)
!embed
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)

!embed

  CODE
!embed
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
!embed
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window
!embed


Resizer.Reset PROCEDURE

!embed

  CODE
!embed
  PARENT.Reset
!embed


Resizer.Resize PROCEDURE

ReturnValue          BYTE,AUTO

!embed

  CODE
!embed
  ReturnValue = PARENT.Resize()
!embed
  RETURN ReturnValue


Resizer.Resize PROCEDURE(SIGNED Control)

ReturnValue          BYTE,AUTO

!embed

  CODE
!embed
  ReturnValue = PARENT.Resize(Control)
!embed
  RETURN ReturnValue


Resizer.RestoreWindow PROCEDURE

!embed

  CODE
!embed
  PARENT.RestoreWindow
!embed


Resizer.SetParentDefault PROCEDURE

!embed

  CODE
!embed
  PARENT.SetParentDefault
!embed


Resizer.SetParentDefaults PROCEDURE

!embed

  CODE
!embed
  PARENT.SetParentDefaults
!embed


Resizer.SetPosition PROCEDURE(SIGNED Control,*PositionGroup ParentOrigPos,*PositionGroup ParentNewPos,*PositionGroup OrigPos,*PositionGroup NewPos)

!embed

  CODE
!embed
  PARENT.SetPosition(Control,ParentOrigPos,ParentNewPos,OrigPos,NewPos)
!embed

!embed
